/* 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * Contributor(s): Eric Murphy, ericmurphy@jabber.org
 *                             
 * Date: 2001.01.02
 *
 */

function InMemoryRDFDataSource()
{
   this.rdf = Components.classes['@mozilla.org/rdf/rdf-service;1'].
                                  getService(Components.interfaces.nsIRDFService);

   this.datasource = Components.classes['@mozilla.org/rdf/datasource;1?name=in-memory-datasource'].
                                         createInstance(Components.interfaces.nsIRDFDataSource);  

   this.root = this.rdf.GetResource('urn:root');
   this.jids = this.rdf.GetAnonymousResource();

   this.datasource.Assert(this.root,
	                  this.rdf.GetResource('http://www.jabber.org/rdf#jids'),
	                  this.jids,
	                  true);

   this.rdfc = Components.classes['@mozilla.org/rdf/container-utils;1'].
                                    getService(Components.interfaces.nsIRDFContainerUtils);

   this.sequence = this.rdfc.MakeSeq(this.datasource, this.jids);

   this.rdfs = Components.classes['@mozilla.org/rdf/container;1'].
                                    getService(Components.interfaces.nsIRDFContainer);
}