/* 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * Contributor(s): Eric Murphy, ericmurphy@jabber.org
 *
 * Date: 2002.04.03
 *
 */

//netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
//var jabberXM = new Components.Constructor('@jabberxm.mozdev.org;1','JabberXM');
//jabber = new jabberXM();

var room;
var username;
var canvas;
var stat=document.getElementById('stat');

/***************************************************************************/

function loadLogin()
{
  window.open('wb-logins.xul','','chrome');
}

function cancel()
{
  window.close();
}

function chatHandler() {
  this.wrappedJSObject = this;

  this.chatHandler = function(from,subject,body,html) {

    if(subject != '')
      document.getElementById('subject').value = subject;

    if(html=='') {
      chatContentAddMsgToLog(from,subject,body);
    }
    else {
      html = html.replace(/ xmlns="http:\/\/www.w3.org\/1999\/xhtml"/i,"");
      chatContentAddMsgToLog(from,subject,html);
    }

    
    if(body.substring(0,3) == '/me')
      body=body.substring(4,body.length)

    stat.setAttribute('value',from+': '+body);

  }
}

function connect()
{
  // This is the <canvas/> that the binding is attached to
  canvas = frames[1].document.childNodes[3].childNodes[1];

  //room     = document.getElementById('room').value;
  //username = document.getElementById('username').value;

  contents = "<query xmlns='jabber:iq:conference'></query>";
  jabber.sendIQ(room,'get','',contents);

  jabber.sendPresence(room);

  contents = "<query xmlns='jabber:iq:conference'><nick>"+username+"</nick></query>";
  jabber.sendIQ(room,'set','',contents);

  window.title='Jabberzilla Whiteboard :: ' + room;

  document.getElementById('name').value=username;

  jabber.setConferenceChatHandler(room,new chatHandler());

  setTimeout('getRoster()',1000);
}

/***************************************************************************/
// This section handles the callback of incoming whiteboard messages.

function append(w)
{
  frames[1].document.childNodes[3].childNodes[1].append(w);
}

function whiteboardHandler()
{
   this.wrappedJSObject = this;

   this.handleWhiteboard = function(from,body,w)
   {
      if(body != '')
      {
         stat.setAttribute('value',from+''+body);
      }
      if(from != '' && from != username)
      {
         previousMODE = MODE;
         //w = w.substring(34,w.length-6);
         //w = w +' xmlns="http://www.w3.org/2000/svg"/>';

         w = w.replace(/jabberzilla:whiteboard/i,"http://www.w3.org/2000/svg");

         canvas.appendIncomingObject(from,w);
      }
   }
}

jabber.setWhiteboardHandler(new whiteboardHandler());

/***************************************************************************/
// This section handles whiteboard roster

function getRoster()
{
  datasource = jabber.getConferenceRoster(room);
  presence = jabber.getPresenceDataSource();

  body = document.getElementById('roster-tree');
  body.database.AddDataSource(datasource);
  body.database.AddDataSource(presence);
  body.builder.rebuild();
}

/***************************************************************************/
// This section is the timer for drawing elements in the canvas.
// The dependency is that draw() exists in the binding.
// Unfortunately, this code will not execute inside the binding.

function DrawTime(){ stop = true; }

DrawTime.prototype.start = function()
{
  if(!canvas.drawBusy)
  {
    drawTime.stop = false;
    drawTime.run();
  }
  else
    setTimeout('drawTime.start()',500);
}

DrawTime.prototype.run = function()
{    
  if(!drawTime.stop)
  {
    canvas.draw();
    setTimeout('drawTime.run()',50);
  }
}

drawTime = new DrawTime();


/***************************************************************************/

var csButton=document.getElementById('csButton');

function hideChangeSubjectButton()
{
  csButton.setAttribute('class','hidden');
}

function showChangeSubjectButton()
{
  csButton.setAttribute('class','shown');
}

function changeSubject()
{
  subjectv = document.getElementById('subject').value;
  jabber.sendGroupChat
    (room,subjectv,'/me has changed subject to: ' + subjectv,'','','');
}

function changeStatus()
{
  presenceMenu = document.getElementById('presenceMenu');

  jabber.sendXML('<presence to="'+room+'"><show>'+presenceMenu.label+'</show><status>'+presenceMenu.label+'</status></presence>');
}