/* 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * Contributor(s): Eric Murphy, ericmurphy@jabber.org
 *                 Rob Ginda,   rginda@netscape.com
 *
 * Date: 2002.04.03
 *
 */

netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
var jabberXM = new Components.Constructor('@jabberxm.mozdev.org;1','JabberXM');
jabber = new jabberXM();


function chatHandler()
{
   this.wrappedJSObject = this;

   this.chatHandler = function(jid,subject,body)
   {
      chatContentAddMsgToLog(jid,subject,body);
   }
}
jabber.setChatHandler(chatHandler);


function PREchatHandler(jid,subject,body,html)
{
   if(html=='')
   {
      chatContentAddMsgToLog(jid,subject,body);
   }
   else
   {
      chatContentAddMsgToLog(jid,subject,html);
   }
}

var theRange;
var theBody;
var justOpened = true;

function onWinLoad()
{
   window.title = 'Chat with ' + window.name;

   startUpEditor(document.getElementById("ComposeWnd"));

   theRange = frames[0].document.createRange();
   theBody  = frames[0].document.getElementsByTagName('body').item(0);
   theRange.setStartAfter(theBody);

   if (window.html == '')
   {
      if(window.body)
         chatContentAddMsgToLog(window.name,'',window.body);
   }
   else
   {
      if(window.body)
         chatContentAddMsgToLog(window.name,'',window.html);
   }
}

function onWinUnLoad()
{
   jabber.closeChat(window.name);
}

function onWinFocus()
{
      window.editorShell.contentWindow = window._content;
      window.editorShell.webShellWindow = window;
}

function startUpEditor(editorElement)
{
   var editorShell = editorElement.editorShell;
   if(editorShell)
   {			
      // save the editorShell in the window. The editor JS expects to find it there.
      window.editorShell = editorShell;

      //SetupToolbarElements(); //defined into editor.js
      window.editorShell.editorType = "html";

      window.editorShell.contentWindow = window._content;
      window.editorShell.webShellWindow = window;
      window.editorShell.LoadUrl("about:blank");
      EditorSharedStartup();
   }
   else
   {
      dump("No editorShell found\n");
      return;
   }
}

function sendOnEnter()
{
   entered = document.getElementById('entered');

   if (entered.checked)
   {
      return true;
   }
   else
   {
      return false;
   }
}

function toXHTML(html)
{
   //var xhtml = ('<html xmlns="http://www.w3.org/1999/xhtml">' + html);
   xhtml = html.replace(/<br>/g,'<br/>');
   return xhtml;
}

function chatContentSendMsg(strip)
{
   var bodyText = editorShell.GetContentsAs("text/plain", 8 + 4 + 256);
   var bodyHTML = editorShell.GetContentsAs("text/html", 8 + 4 + 256);
	
   if (strip == true)
   {
      bodyText = bodyHTML.replace(/<br>/gi, "");
      bodyText = bodyHTML.replace(/\n/g, "");
      bodyText = bodyHTML.replace(/\r/g, "");
   }

   bodyHTML = bodyHTML.replace(/\n/g, "");
   bodyHTML = bodyHTML.replace(/\r/g, "");
   bodyHTML = bodyHTML.replace(/&nbsp;/gi, " ");
   bodyHTML = toXHTML(bodyHTML);
   bodyHTML = bodyHTML.replace(/<\/html>/i, "");

   jabber.sendChat(window.name,'',bodyText,bodyHTML,'');
   chatContentAddMsgToLog('me','',bodyHTML);

   top.editorShell.SelectAll();
   top.editorShell.DeleteSelection(0);
      window.editorShell.LoadUrl("about:blank"); // HACK... bogus_node
   top._content.focus();

   //chatSound(Components.interfaces.nsAimChatSoundEvent.ChatSoundEvent_OutgoingMsg);
}

function chatContentAddMsgToLog(screenName,subject,msg,isMsg)
{
   var theLogNode = top.frames['LogWnd'];
	
   var myRange = theLogNode.document.createRange();
   var theLogBody =theLogNode.document.getElementsByTagName("body").item(0);


   myRange.setStartAfter(theLogBody);

   var docFrag;
   docFrag = myRange.createContextualFragment('<html><font face="Verdana, Arial, Helvetica, sans-serif" size="2">'
             +'<font color="red">'+screenName+': </font>'+msg+'</font></html><br>');

   theLogBody.appendChild(docFrag)

   theLogNode.scrollTo(theLogNode.scrollX, theLogNode.document.height);
}

function composeFocus(boolval)
{
   dump( "composeFocus" + boolval + "\n" );
   if ( top.imObject )
        top.imObject.editorHasFocus = boolval;
}

function logFocus(boolval)
{
   dump( "logFocus" + boolval + "\n" );
   if ( top.imObject )
        top.imObject.logHasFocus = boolval;
}

function cmdEditCut()
{
   dump("Implement Menu Command cmdEditCut()\n");
   if ( top.imObject.editorHasFocus == true   )
   {
      dump( "Focus window is edit wnd\n" );
      EditorCut();
   }
}

function cmdEditCopy()
{
   dump("Implement Menu Command cmdEditCopy()\n");
   if ( top.imObject.logHasFocus == true )
   {
      dump( "Focus window is log wnd\n" );
   } 
   else if ( top.imObject.editorHasFocus == true   )
   {
      dump( "Focus window is edit wnd\n" );
      EditorCopy();
   }
}

function cmdEditPaste()
{
   dump("Implement Menu Command cmdEditPaste()\n");
   if ( top.imObject.editorHasFocus == true   )
   {
      dump( "Focus window is edit wnd\n" );
      EditorPaste();
   }
}

function cmdEditSelectAll()
{
   dump("Implement Menu Command cmdEditSelectAll()\n");
   if ( top.imObject.logHasFocus == true )
   {
      dump( "Focus window is log wnd\n" );
   } 
   else if ( top.imObject.editorHasFocus == true   )
   {
      dump( "Focus window is edit wnd\n" );
      EditorSelectAll();
   }
}